"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertTSTypeAliasDeclaration = void 0;
const t = __importStar(require("@babel/types"));
const convertTSType_1 = require("./convertTSType");
const convertTSTypeParameterDeclaration_1 = require("./convertTSTypeParameterDeclaration");
const baseNodeProps_1 = require("../utils/baseNodeProps");
function convertTSTypeAliasDeclaration(node, isAmbientContext) {
    const typeParameters = node.typeParameters;
    const typeAnnotation = node.typeAnnotation;
    const typeAlias = node.declare || isAmbientContext ? t.declareTypeAlias : t.typeAlias;
    return typeAlias(node.id, typeParameters
        ? Object.assign(Object.assign({}, convertTSTypeParameterDeclaration_1.convertTSTypeParameterDeclaration(typeParameters)), baseNodeProps_1.baseNodeProps(typeParameters)) : null, Object.assign(Object.assign({}, baseNodeProps_1.baseNodeProps(typeAnnotation)), convertTSType_1.convertTSType(typeAnnotation)));
}
exports.convertTSTypeAliasDeclaration = convertTSTypeAliasDeclaration;
//# sourceMappingURL=convertTSTypeAliasDeclaration.js.map