import * as t from '@babel/types';
export declare function convertFunctionTypeAnnotation(node: t.TSFunctionType | t.TSMethodSignature | t.TSCallSignatureDeclaration | t.TSDeclareFunction | t.TSDeclareMethod): {
    typeParams: {
        leadingComments: readonly t.Comment[] | null;
        innerComments: readonly t.Comment[] | null;
        trailingComments: readonly t.Comment[] | null;
        start: number | null;
        end: number | null;
        loc: t.SourceLocation | null;
        range?: [number, number] | undefined;
        extra?: Record<string, unknown> | undefined;
        type: "TypeParameterDeclaration";
        params: t.TypeParameter[];
    } | undefined;
    parameters: t.FunctionTypeParam[];
    rest: t.FunctionTypeParam | null;
    returnType: t.FlowType | null;
};
//# sourceMappingURL=convertFunctionTypeAnnotation.d.ts.map